vsg: vsg::ShaderSet Class Reference

vsg 1.1.13 VulkanSceneGraph library

Loading...
Searching...
No Matches
vsg::ShaderSet Class Reference

ShaderSet provides a collection of shader related settings to provide a form of shader introspection. More...

`#include <ShaderSet.h>`

Inheritance diagram for vsg::ShaderSet:
[legend]
Collaboration diagram for vsg::ShaderSet:
[legend]

## Public Member Functions
| ShaderSet (const ShaderStages &in_stages, ref_ptr< ShaderCompileSettings > in_hints={})
void | addAttributeBinding (const std::string &name, const std::string &define, uint32_t location, VkFormat format, ref_ptr< Data > data, CoordinateSpace coordinateSpace=CoordinateSpace::NO_PREFERENCE)
| add an attribute binding, Not thread safe, should only be called when initially setting up the ShaderSet
void | addDescriptorBinding (const std::string &name, const std::string &define, uint32_t set, uint32_t binding, VkDescriptorType descriptorType, uint32_t descriptorCount, VkShaderStageFlags stageFlags, ref_ptr< Data > data, CoordinateSpace coordinateSpace=CoordinateSpace::NO_PREFERENCE)
| add an uniform binding. Not thread safe, should only be called when initially setting up the ShaderSet
void | addUniformBinding (const std::string &name, const std::string &define, uint32_t set, uint32_t binding, VkDescriptorType descriptorType, uint32_t descriptorCount, VkShaderStageFlags stageFlags, ref_ptr< Data > data)
void | addPushConstantRange (const std::string &name, const std::string &define, VkShaderStageFlags stageFlags, uint32_t offset, uint32_t size)
| add a push constant range. Not thread safe, should only be called when initially setting up the ShaderSet
AttributeBinding & | getAttributeBinding (const std::string &name)
| get the AttributeBinding associated with name
const AttributeBinding & | getAttributeBinding (const std::string &name) const
| get the const AttributeBinding associated with name
DescriptorBinding & | getDescriptorBinding (const std::string &name)
| get the DescriptorBinding associated with name
const DescriptorBinding & | getDescriptorBinding (const std::string &name) const
| get the const DescriptorBinding associated with name
DescriptorBinding & | getUniformBinding (const std::string &name)
const DescriptorBinding & | getUnifomrBinding (const std::string &name) const
ref_ptr< ArrayState > | getSuitableArrayState (const std::set< std::string > &defines) const
| get the first ArrayState that has matches with defines in the specified list of defines.
ShaderStages | getShaderStages (ref_ptr< ShaderCompileSettings > scs={})
| get the ShaderStages variant that uses specified ShaderCompileSettings.
std::pair< uint32_t, uint32_t > | descriptorSetRange () const
| return the <minimum_set, maximum_set+1> range of set numbers encompassing DescriptorBindings
virtual bool | compatibleDescriptorSetLayout (const DescriptorSetLayout &dsl, const std::set< std::string > &defines, uint32_t set) const
| return true of specified descriptor set layout is compatible with what is required for this ShaderSet
virtual ref_ptr< DescriptorSetLayout > | createDescriptorSetLayout (const std::set< std::string > &defines, uint32_t set) const
| create the descriptor set layout.
virtual bool | compatiblePipelineLayout (const PipelineLayout &layout, const std::set< std::string > &defines) const
| return true of specified pipeline layout is compatible with what is required for this ShaderSet
ref_ptr< PipelineLayout > | createPipelineLayout (const std::set< std::string > &defines)
| create the pipeline layout for all descriptor sets enabled by specified defines or required by default.
virtual ref_ptr< PipelineLayout > | createPipelineLayout (const std::set< std::string > &defines, std::pair< uint32_t, uint32_t > range) const
int | compare (const Object &rhs) const override
| compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,
void | read (Input &input) override
void | write (Output &output) const override
Public Member Functions inherited from vsg::Inherit< Object, ShaderSet >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
void | accept (Visitor &visitor) override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | accept (ConstVisitor &visitor) const
virtual void | traverse (ConstVisitor &) const
virtual void | accept (RecordTraversal &visitor) const
virtual void | traverse (RecordTraversal &) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
ShaderStages | stages
| base ShaderStages that other variants are based on.
std::vector< AttributeBinding > | attributeBindings
std::vector< DescriptorBinding > | descriptorBindings
std::vector< PushConstantRange > | pushConstantRanges
std::vector< DefinesArrayState > | definesArrayStates
std::set< std::string > | optionalDefines
GraphicsPipelineStates | defaultGraphicsPipelineStates
std::vector< ref_ptr< CustomDescriptorSetBinding > > | customDescriptorSetBindings
ref_ptr< ShaderCompileSettings > | defaultShaderHints
std::map< ref_ptr< ShaderCompileSettings >, ShaderStages, DereferenceLess > | variants
| variants of the rootShaderModule compiled for different combinations of ShaderCompileSettings
std::mutex | mutex
| mutex used by getShaderStages(..) to ensure the variants map can be used from multiple threads.

## Protected Attributes
AttributeBinding | _nullAttributeBinding
DescriptorBinding | _nullDescriptorBinding

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, ShaderSet >
static ref_ptr< ShaderSet > | create (Args &&... args)
static ref_ptr< ShaderSet > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

ShaderSet provides a collection of shader related settings to provide a form of shader introspection.

## Member Function Documentation

## ◆ compare()

int vsg::ShaderSet::compare | ( | const Object & | rhs | ) | const
| overridevirtual

compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,

Reimplemented from vsg::Inherit< Object, ShaderSet >.

## ◆ createPipelineLayout()

virtual ref_ptr< PipelineLayout > vsg::ShaderSet::createPipelineLayout | ( | const std::set< std::string > & | defines,
|  | std::pair< uint32_t, uint32_t > | range ) const
| virtual

create pipeline layout for specified range <minimum_set, maximum_set+1> of descriptor sets that are enabled by specified defines or required by default.

Note: the underlying Vulkan call vkCreatePipelineLayout assumes that the array of descriptor sets starts with set 0. Therefore the minimum_set argument should be 0 unless you really know what you're doing.

## ◆ read()

void vsg::ShaderSet::read | ( | Input & | input | ) |
| overridevirtual

Reimplemented from vsg::Object.

## ◆ write()

void vsg::ShaderSet::write | ( | Output & | output | ) | const
| overridevirtual

Reimplemented from vsg::Object.

The documentation for this class was generated from the following file:

- include/vsg/utils/ShaderSet.h